-- ****************************************************
-- Created by: ACTgen 3.3.1
-- Date: Thu Feb 11 17:23:23 1999
-- Parameters:
--   WIDTH:16
--   CLR_POLARITY:2
--   EN_POLARITY:1
--   CLK_EDGE:RISE
-- ***************************************************


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

entity sshift is

  port(Data : in std_logic_vector(15 downto 0);
       Enable : in std_logic;
       Shiften : in std_logic;
       Shiftin : in std_logic;
       Clock : in std_logic;
       Q : out std_logic_vector(15 downto 0));

end sshift;

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

architecture behavioral of sshift is
  signal Qaux : std_logic_vector(15 downto 0);
begin

  process (Clock)
  begin

    if (Clock'event and Clock = '1') then
      if (Enable = '1') then
        Qaux <= Data;
      elsif (Shiften = '1') then
        Qaux <= Qaux(14 downto 0) & Shiftin;
      end if;
    end if;

  end process;

  Q <= Qaux;

end behavioral;
